<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>discover: /home/pere/src/debiancvs/pkg-discover/discover/trunk/lib/version-cmp.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.4.2 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="dirs.html">Directories</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="globals.html">Globals</a></div>
<div class="nav">
<a class="el" href="dir_000002.html">lib</a></div>
<h1>version-cmp.c</h1><a href="version-cmp_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment">00001 
00011 <span class="comment">/* $Progeny$</span>
00012 <span class="comment"> *</span>
00013 <span class="comment"> * AUTHOR: John R. Daily &lt;jdaily@progeny.com&gt;</span>
00014 <span class="comment"> *</span>
00015 <span class="comment"> * Copyright 2002 Progeny Linux Systems, Inc.</span>
00016 <span class="comment"> * Copyright 2002 Hewlett-Packard Company</span>
00017 <span class="comment"> *</span>
00018 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
00019 <span class="comment"> * copy of this software and associated documentation files (the "Software"),</span>
00020 <span class="comment"> * to deal in the Software without restriction, including without limitation</span>
00021 <span class="comment"> * the rights to use, copy, modify, merge, publish, distribute, sublicense,</span>
00022 <span class="comment"> * and/or sell copies of the Software, and to permit persons to whom the</span>
00023 <span class="comment"> * Software is furnished to do so, subject to the following conditions:</span>
00024 <span class="comment"> *</span>
00025 <span class="comment"> * The above copyright notice and this permission notice shall be included in</span>
00026 <span class="comment"> * all copies or substantial portions of the Software.</span>
00027 <span class="comment"> *</span>
00028 <span class="comment"> * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
00029 <span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
00030 <span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL</span>
00031 <span class="comment"> * THE COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
00032 <span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING</span>
00033 <span class="comment"> * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER</span>
00034 <span class="comment"> * DEALINGS IN THE SOFTWARE.</span>
00035 <span class="comment"> */</span>
00036 
00037 <span class="comment">/*</span>
00038 <span class="comment"> * This package should include a state machine diagram that</span>
00039 <span class="comment"> * is important to understanding this code.</span>
00040 <span class="comment"> */</span>
00041 
00042 <span class="preprocessor">#include "config.h"</span>
00043 
00044 <span class="preprocessor">#include &lt;assert.h&gt;</span>
00045 <span class="preprocessor">#include &lt;ctype.h&gt;</span>
00046 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
00047 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
00048 <span class="preprocessor">#include &lt;string.h&gt;</span>
00049 
00050 <span class="preprocessor">#include &lt;<a class="code" href="discover_8h.html">discover/discover.h</a>&gt;</span>
00051 
00052 <span class="preprocessor">#include &lt;discover/utils.h&gt;</span>
00053 
<a name="l00055"></a><a class="code" href="version-cmp_8c.html#a0">00055</a> <span class="preprocessor">#define MAXBUFLEN 256</span>
00056 <span class="preprocessor"></span>
<a name="l00058"></a><a class="code" href="version-cmp_8c.html#a21">00058</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> <a class="code" href="version-cmp_8c.html#a21">range_states</a> {
00059     START,
00060     OPEN,
00061     VERSION1,
00062     VERSEP1,
00063     PAUSE1,
00064     SEPARATOR,
00065     I, N, F,
00066     VERSION2,
00067     VERSEP2,
00068     PAUSE2,
00069     CLOSE,
00070     ERROR
00071 }
00073 <a class="code" href="version-cmp_8c.html#a1">range_state</a>;
00074 
00075 <span class="comment">/*</span>
00076 <span class="comment"> * For now, we only understand '.' as a separator, but that could</span>
00077 <span class="comment"> * change.</span>
00078 <span class="comment"> */</span>
00079 <span class="keyword">static</span> <span class="keywordtype">int</span>
00080 is_versep_char(<span class="keywordtype">char</span> c)
00081 {
00082     <span class="keywordflow">return</span> c == <span class="charliteral">'.'</span>;
00083 }
00084 
00085 <span class="comment">/*</span>
00086 <span class="comment"> * Wrapper for isdigit(), in case we want to add more legitimate</span>
00087 <span class="comment"> * version characters later.</span>
00088 <span class="comment"> */</span>
00089 <span class="keyword">static</span> <span class="keywordtype">int</span>
00090 is_version_char(<span class="keywordtype">char</span> c)
00091 {
00092     <span class="keywordflow">return</span> isdigit(c);
00093 }
00094 
00095 <span class="comment">/*</span>
00096 <span class="comment"> * We only handle dot-separated integers. Anything else becomes</span>
00097 <span class="comment"> * subject to interpretation.</span>
00098 <span class="comment"> *</span>
00099 <span class="comment"> * Return values:</span>
00100 <span class="comment"> *   1 - v1 is higher</span>
00101 <span class="comment"> *   0 - v2 is higher</span>
00102 <span class="comment"> *  -1 - v1, v2 are equivalent</span>
00103 <span class="comment"> *</span>
00104 <span class="comment"> * The string "inf" represents an undefined upper bound; the equivalent on</span>
00105 <span class="comment"> * the lower bound should be 0.</span>
00106 <span class="comment"> */</span>
00107 <span class="keyword">static</span> <span class="keywordtype">int</span>
00108 version_compare(<span class="keyword">const</span> <span class="keywordtype">char</span> *<span class="keyword">const</span> v1, <span class="keyword">const</span> <span class="keywordtype">char</span> *<span class="keyword">const</span> v2)
00109 {
00110     <span class="keywordtype">int</span> int1, int2;
00111     <span class="keywordtype">char</span> *word1, *word2;
00112     <span class="keywordtype">char</span> *version1, *version2;
00113     <span class="keywordtype">char</span> *buffer1;
00114     <span class="keywordtype">char</span> *buffer2;
00115 
00116     <span class="keywordflow">if</span> (strcmp(v1, v2) == 0) {
00117         <span class="keywordflow">return</span> -1;
00118     }
00119 
00120     <span class="keywordflow">if</span> (strcmp(v1, <span class="stringliteral">"inf"</span>) == 0) {
00121         <span class="keywordflow">return</span> 1;
00122     }
00123 
00124     <span class="keywordflow">if</span> (strcmp(v2, <span class="stringliteral">"inf"</span>) == 0) {
00125         <span class="keywordflow">return</span> 0;
00126     }
00127 
00128     buffer1 = _discover_xmalloc(<a class="code" href="version-cmp_8c.html#a0">MAXBUFLEN</a>);
00129     buffer2 = _discover_xmalloc(<a class="code" href="version-cmp_8c.html#a0">MAXBUFLEN</a>);
00130 
00131     version1 = _discover_xstrdup(v1);
00132     version2 = _discover_xstrdup(v2);
00133 
00134     word1 = strtok_r(version1, <span class="stringliteral">"."</span>, &amp;buffer1);
00135     word2 = strtok_r(version2, <span class="stringliteral">"."</span>, &amp;buffer2);
00136 
00137     <span class="keywordflow">do</span> {
00138         sscanf(word1, <span class="stringliteral">"%d"</span>, &amp;int1);
00139         sscanf(word2, <span class="stringliteral">"%d"</span>, &amp;int2);
00140 
00141         <span class="keywordflow">if</span> (int1 != int2) {
00142             <span class="keywordflow">return</span> int1 &gt; int2;
00143         }
00144 
00145         word1 = strtok_r(NULL, <span class="stringliteral">"."</span>, &amp;buffer1);
00146         word2 = strtok_r(NULL, <span class="stringliteral">"."</span>, &amp;buffer2);
00147 
00148     } <span class="keywordflow">while</span>(word1 != NULL &amp;&amp; word2 != NULL);
00149 
00150     free(version1);
00151     free(version2);
00152 
00153     <span class="keywordflow">if</span> (word2 == NULL &amp;&amp; word1 == NULL) {
00154         <span class="keywordflow">return</span> -1;
00155     }
00156     <span class="keywordflow">if</span> (word2 == NULL) {
00157         <span class="keywordflow">return</span> 1;
00158     }
00159     <span class="keywordflow">return</span> -0;
00160 }
00161 
00162 
00163 <span class="keyword">static</span> <span class="keywordtype">int</span>
00164 determine_range(<span class="keywordtype">char</span> * range_text, <span class="keywordtype">char</span> **upper,
00165                 <span class="keywordtype">int</span> *upper_inclusive, <span class="keywordtype">char</span> **lower, <span class="keywordtype">int</span> *lower_inclusive,
00166                 <span class="keywordtype">char</span> **next)
00167 {
00168     <span class="keywordtype">char</span> *current = range_text;
00169     <span class="keywordtype">char</span> c;
00170     <span class="keywordtype">char</span> last_char = <span class="charliteral">'\0'</span>;
00171 
00172     <span class="keywordtype">char</span> buffer1[<a class="code" href="version-cmp_8c.html#a0">MAXBUFLEN</a>];
00173     <span class="keywordtype">char</span> *bufptr1 = buffer1;
00174 
00175     <span class="keywordtype">char</span> buffer2[<a class="code" href="version-cmp_8c.html#a0">MAXBUFLEN</a>];
00176     <span class="keywordtype">char</span> *bufptr2 = buffer2;
00177 
00178     <a class="code" href="version-cmp_8c.html#a1">range_state</a> <a class="code" href="conf_8c.html#a33">state</a> = START;
00179     <a class="code" href="version-cmp_8c.html#a1">range_state</a> last_good_state = START;
00180     <span class="keywordtype">int</span> first_inclusive = -1, second_inclusive = -1;
00181 
00182     <span class="keywordflow">while</span>(1) {
00183         c = *current;
00184 
00185         <span class="keywordflow">switch</span>(state) {
00186         <span class="keywordflow">case</span> START:
00187             <span class="keywordflow">if</span> (isspace(c)) {
00188                 state = START;
00189             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (c == <span class="charliteral">'('</span> || c == <span class="charliteral">'['</span>) {
00190                 state = OPEN;
00191             } <span class="keywordflow">else</span> {
00192                 last_good_state = state;
00193                 state = ERROR;
00194             }
00195             <span class="keywordflow">break</span>;
00196 
00197         <span class="keywordflow">case</span> OPEN:
00198             <span class="keywordflow">if</span> (last_char == <span class="charliteral">'['</span>) {
00199                 first_inclusive = 1;
00200             } <span class="keywordflow">else</span> {
00201                 first_inclusive = 0;
00202             }
00203 
00204             <span class="keywordflow">if</span> (isspace(c)) {
00205                 state = OPEN;
00206             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (is_version_char(c)) {
00207                 state = VERSION1;
00208             } <span class="keywordflow">else</span> {
00209                 last_good_state = state;
00210                 state = ERROR;
00211             }
00212             <span class="keywordflow">break</span>;
00213 
00214         <span class="keywordflow">case</span> VERSION1:
00215             <span class="keywordflow">if</span> (bufptr1 - buffer1 &gt; 254) {
00216                 last_good_state = state;
00217                 state = ERROR;
00218                 <span class="keywordflow">break</span>;
00219             }
00220 
00221             *bufptr1 = last_char;
00222             bufptr1++;
00223 
00224             <span class="keywordflow">if</span> (isspace(c) || c == <span class="charliteral">','</span>) {
00225                 *bufptr1 = <span class="charliteral">'\0'</span>;
00226 
00227                 <span class="keywordflow">if</span> (c == <span class="charliteral">','</span>) {
00228                     state = SEPARATOR;
00229                 } <span class="keywordflow">else</span> {
00230                     state = PAUSE1;
00231                 }
00232             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (is_version_char(c)) {
00233                 state = VERSION1;
00234             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (is_versep_char(c)) {
00235                 state = VERSEP1;
00236             } <span class="keywordflow">else</span> {
00237                 last_good_state = VERSION1;
00238                 state = ERROR;
00239             }
00240             <span class="keywordflow">break</span>;
00241 
00242         <span class="keywordflow">case</span> VERSEP1:
00243             <span class="keywordflow">if</span> (bufptr1 - buffer1 &gt; 254) {
00244                 last_good_state = state;
00245                 state = ERROR;
00246                 <span class="keywordflow">break</span>;
00247             }
00248 
00249             *bufptr1 = last_char;
00250             bufptr1++;
00251 
00252             <span class="keywordflow">if</span> (is_version_char(c)) {
00253                 state = VERSION1;
00254             } <span class="keywordflow">else</span> {
00255                 last_good_state = VERSION1;
00256                 state = ERROR;
00257             }
00258             <span class="keywordflow">break</span>;
00259 
00260         <span class="keywordflow">case</span> PAUSE1:
00261             <span class="keywordflow">if</span> (isspace(c)) {
00262                 state = PAUSE1;
00263             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (c == <span class="charliteral">','</span>) {
00264                 state = SEPARATOR;
00265             } <span class="keywordflow">else</span> {
00266                 last_good_state = PAUSE1;
00267                 state = ERROR;
00268             }
00269             <span class="keywordflow">break</span>;
00270 
00271         <span class="keywordflow">case</span> SEPARATOR:
00272             <span class="keywordflow">if</span> (isspace(c)) {
00273                 state = SEPARATOR;
00274             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (is_version_char(c)) {
00275                 state = VERSION2;
00276             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (c == <span class="charliteral">'i'</span>) {
00277                 state = I;
00278             } <span class="keywordflow">else</span> {
00279                 last_good_state = SEPARATOR;
00280                 state = ERROR;
00281             }
00282             <span class="keywordflow">break</span>;
00283 
00284         <span class="keywordflow">case</span> I:
00285             <span class="keywordflow">if</span> (c == <span class="charliteral">'n'</span>) {
00286                 state = N;
00287             } <span class="keywordflow">else</span> {
00288                 last_good_state = state;
00289                 state = ERROR;
00290             }
00291             <span class="keywordflow">break</span>;
00292 
00293         <span class="keywordflow">case</span> N:
00294             <span class="keywordflow">if</span> (c == <span class="charliteral">'f'</span>) {
00295                 state = F;
00296             } <span class="keywordflow">else</span> {
00297                 last_good_state = state;
00298                 state = ERROR;
00299             }
00300             <span class="keywordflow">break</span>;
00301 
00302         <span class="keywordflow">case</span> F:
00303             strcpy(bufptr2, <span class="stringliteral">"inf"</span>);
00304             <span class="keywordflow">if</span> (isspace(c)) {
00305                 state = PAUSE2;
00306             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (c == <span class="charliteral">')'</span> || c == <span class="charliteral">']'</span>) {
00307                 state = CLOSE;
00308             } <span class="keywordflow">else</span> {
00309                 last_good_state = state;
00310                 state = ERROR;
00311             }
00312             <span class="keywordflow">break</span>;
00313 
00314         <span class="keywordflow">case</span> VERSION2:
00315             <span class="keywordflow">if</span> (bufptr2 - buffer2 &gt; 254) {
00316                 last_good_state = state;
00317                 state = ERROR;
00318                 <span class="keywordflow">break</span>;
00319             }
00320 
00321             *bufptr2 = last_char;
00322             bufptr2++;
00323 
00324             <span class="keywordflow">if</span> (isspace(c) || c == <span class="charliteral">')'</span> || c == <span class="charliteral">']'</span>) {
00325                 *bufptr2 = <span class="charliteral">'\0'</span>;
00326 
00327                 <span class="keywordflow">if</span> (c == <span class="charliteral">')'</span> || c == <span class="charliteral">']'</span>) {
00328                     state = CLOSE;
00329                 } <span class="keywordflow">else</span> {
00330                     state = PAUSE2;
00331                 }
00332             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (is_version_char(c)) {
00333                 state = VERSION2;
00334             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (is_versep_char(c)) {
00335                 state = VERSEP2;
00336             } <span class="keywordflow">else</span> {
00337                 last_good_state = VERSION2;
00338                 state = ERROR;
00339             }
00340             <span class="keywordflow">break</span>;
00341 
00342         <span class="keywordflow">case</span> VERSEP2:
00343             <span class="keywordflow">if</span> (bufptr2 - buffer2 &gt; 254) {
00344                 last_good_state = state;
00345                 state = ERROR;
00346                 <span class="keywordflow">break</span>;
00347             }
00348 
00349             *bufptr2 = last_char;
00350             bufptr2++;
00351 
00352             <span class="keywordflow">if</span> (is_version_char(c)) {
00353                 state = VERSION2;
00354             } <span class="keywordflow">else</span> {
00355                 last_good_state = VERSION2;
00356                 state = ERROR;
00357             }
00358             <span class="keywordflow">break</span>;
00359 
00360         <span class="keywordflow">case</span> PAUSE2:
00361             <span class="keywordflow">if</span> (isspace(c)) {
00362                 state = PAUSE2;
00363             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (c == <span class="charliteral">')'</span> || c == <span class="charliteral">']'</span>) {
00364                 state = CLOSE;
00365             } <span class="keywordflow">else</span> {
00366                 last_good_state = PAUSE2;
00367                 state = ERROR;
00368             }
00369             <span class="keywordflow">break</span>;
00370 
00371         <span class="keywordflow">case</span> CLOSE:
00372             *next = current;
00373 
00374             <span class="keywordflow">if</span> (last_char == <span class="charliteral">')'</span>) {
00375                 second_inclusive = 0;
00376             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (last_char == <span class="charliteral">']'</span>) {
00377                 second_inclusive = 1;
00378             }
00379 
00380             <span class="keywordflow">if</span> (version_compare(buffer1, buffer2) == 1) {
00381                 *upper = _discover_xmalloc(bufptr1 - buffer1 + 1);
00382                 strcpy(*upper, buffer1);
00383                 *upper_inclusive = first_inclusive;
00384 
00385                 *lower = _discover_xmalloc(bufptr2 - buffer2 + 1);
00386                 strcpy(*lower, buffer2);
00387                 *lower_inclusive = second_inclusive;
00388             } <span class="keywordflow">else</span> {
00389                 *lower = _discover_xmalloc(bufptr1 - buffer1 + 1);
00390                 strcpy(*lower, buffer1);
00391                 *lower_inclusive = first_inclusive;
00392 
00393                 *upper = _discover_xmalloc(bufptr2 - buffer2 + 1);
00394                 strcpy(*upper, buffer2);
00395                 *upper_inclusive = second_inclusive;
00396             }
00397 
00398             <span class="comment">/* EXIT POINT */</span>
00399             <span class="keywordflow">return</span> 1;
00400 
00401         <span class="keywordflow">default</span>:
00402             state = ERROR;
00403             last_good_state = -1;
00404             <span class="keywordflow">break</span>;
00405         }
00406 
00407         <span class="keywordflow">if</span> (state == ERROR) {
00408             <span class="comment">/* Do something. */</span>
00409             <span class="keywordflow">return</span> 0;
00410         }
00411 
00412         <span class="comment">/*</span>
00413 <span class="comment">         * We don't care about recording spaces; let's simplify by not</span>
00414 <span class="comment">         * doing so, in case we'd be missing something valuable.</span>
00415 <span class="comment">         */</span>
00416         <span class="keywordflow">if</span> (!isspace(*current)) {
00417             last_char = *current;
00418         }
00419 
00420         current++;
00421     }
00422 }
00423 
00437 <span class="keywordtype">int</span>
<a name="l00438"></a><a class="code" href="group__version__cmp.html#ga0">00438</a> <a class="code" href="group__version__cmp.html#ga0">discover_xml_version_cmp</a>(<span class="keywordtype">char</span> *range, <span class="keywordtype">char</span> *version, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00439 {
00440     <span class="keywordtype">char</span> *upper, *lower;
00441     <span class="keywordtype">int</span> upper_inclusive, lower_inclusive;
00442     <span class="keywordtype">char</span> *next_range;
00443     <span class="keywordtype">int</span> range_count = 0;
00444 
00445     assert(range != NULL);
00446     assert(version != NULL);
00447     assert(status != NULL);
00448 
00449     next_range = range;
00450 
00451     <span class="keywordflow">while</span>(*next_range != <span class="charliteral">'\0'</span>) {
00452         range_count++;
00453         <span class="keywordflow">if</span> (determine_range(next_range, &amp;upper, &amp;upper_inclusive,
00454                             &amp;lower, &amp;lower_inclusive, &amp;next_range)) {
00455             <span class="comment">/*</span>
00456 <span class="comment">             * First test: Does this version match the upper end of the</span>
00457 <span class="comment">             * range exactly? If so, is the upper end of the range</span>
00458 <span class="comment">             * inclusive?</span>
00459 <span class="comment">             *</span>
00460 <span class="comment">             * Second test: Does this version match the lower end of the</span>
00461 <span class="comment">             * range? If so, is the lower end inclusive?</span>
00462 <span class="comment">             *</span>
00463 <span class="comment">             * Finally, is the version higher than the lower end, and lower</span>
00464 <span class="comment">             * then the upper end?</span>
00465 <span class="comment">             */</span>
00466             <span class="keywordflow">if</span> (version_compare(version, upper) == -1
00467                 &amp;&amp; upper_inclusive) {
00468                 <span class="keywordflow">return</span> range_count;
00469             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (version_compare(version, lower) == -1
00470                        &amp;&amp; lower_inclusive) {
00471                 <span class="keywordflow">return</span> range_count;
00472             } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (version_compare(version, lower) &gt; 0 &amp;&amp;
00473                        version_compare(upper, version) &gt; 0) {
00474                 <span class="keywordflow">return</span> range_count;
00475             }
00476 
00477         } <span class="keywordflow">else</span> {
00478             status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = <a class="code" href="group__types.html#gga15a23">DISCOVER_EBADVERSION</a>;
00479             <span class="keywordflow">return</span> -1;
00480         }
00481     }
00482 
00483     <span class="keywordflow">return</span> 0;
00484 }
00485 
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Thu Jul 28 03:38:00 2005 for discover by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.2 </small></address>
</body>
</html>
